8.5. The "Preferences" dialog box
Prev | 8. Dialog boxes | Next

### 8.5. The "Preferences" dialog box

#### 8.5.1. New options

Immediately save newly created document

  When a new document is created using File → New, File → Open as Template or File → Open Copy and this toggle is checked, XXE will immediately prompt the user for a save file name. This save file name is used to actually create on disk the file corresponding to the new document.

  Note that even when this toggle is not checked, XXE may immediately prompt the user for a save file name. This will happen for composite document templates, that is, document templates referencing graphics files and/or including document modules.

  Default: not checked.

  Preference key: `copyDocumentTemplate`; type: boolean; default: `false`.

#### 8.5.2. Open options

Use URL chooser rather than file chooser

  If this toggle is checked, XXE will display an URL chooser dialog box rather than the standard file chooser dialog box each time the user needs to specify a file name.

  This toggle is present only in XMLmind XML Editor Professional Edition.

  Default: not checked.

  Preference key: `useURLChooser`; type: boolean; default: `false`.

When no DTD or schema, guess ignorable white space

  If this toggle is checked, when opening a document not constrained by a DTD or a schema, white space characters are stripped from elements containing child elements separated by white space.

  This heuristic is generally a good one for XML data.

  Default: checked.

  Preference key: `guessIgnorableWhitespace`; type: boolean; default: `true`.

When no DTD or schema, simulate a DTD

  If this toggle is checked, a dynamic, non constraining, pseudo DTD is used for documents not conforming to a DTD or schema.

  The pseudo DTD simply remembers all attributes and child elements added to each element during the editing session. Thanks to this pseudo DTD, the pick lists of the Edit and Attributes tools are always filled with sensible values.

  Default: checked.

  Preference key: `useHelperDocumentType`; type: boolean; default: `true`.

Ignore <?xml-stylesheet?>

  If this toggle is checked, xml-stylesheet processing instructions specifying which style sheets to use for the newly loaded document are ignored. If the XXE configuration associated to the newly loaded document specifies CSS style sheets, these style sheets are used instead.

  Using this option is useful if `<?xml-stylesheet?>` specifies a style sheet for use by a Web browser such as Mozilla and not a style sheet for use by XXE.

  Default: not checked.

  Preference key: `ignoreStyleSheetPI`; type: boolean; default: `false`.

Inform about non-editable document parts

  If this toggle is checked and if the document being opened is modular (that is, contains references to nodes coming from other documents), XXE display a dialog box informing the user that included nodes have been marked as non-editable.

  Default: checked.

  Preference key: `infoAboutReadOnlyInclusions`; type: boolean; default: `true`.

Lock documents stored on the local filesystem

  If this toggle is checked, the file containing the document being opened in the editor is automatically locked using an advisory, application-level, lock.

  In practice, this means that:

  - Applications other XXE can open and modify the document being edited in an instance of XXE.

  - If you try to open in XXE a document being edited in another instance of XXE (run by you or by one of your coworkers), XXE will inform you that the file is locked and will tell you who is locking it. After that you'll be able to open the document but, if you modify it, you'll have to save it to another location.

  Caveat: In order to use this facility, you and all your coworkers possibly editing the same files, need to turn this option on. If one of your coworkers forgets to do it, XXE will not be able to detect that the file being opened is locked, and in such case, your coworker may overwrite a document being edited by another person.

  ### How to forcibly remove a lock

  A lock is implemented by the means of a hidden text file containing information about who has locked the corresponding document.

  On Windows, the lock file corresponding to document `C:\doc\doc.xml` is `C:\doc\doc.xml.LOCK` (with the hidden attribute set on this file).

  On the other platforms, the lock file corresponding to document `/home/john/doc/doc.xml` is `/home/john/doc/.doc.xml.LOCK`.

  Manually deleting the lock file forcibly removes the lock set on the corresponding document. Note that it is harmless to delete such lock files and this, at any time.

  Default: not checked.

  Preference key: `lockLocalDocuments`; type: boolean; default: `false`.

When possible, lock documents stored on remote filesystems

  Unlike the above toggle, this form applies only to files stored on filesystems other than the local one (WebDAV, FTP, Zip, etc).

  This group of options is present only in XMLmind XML Editor Professional Edition.

  Preferred lock mode

    Specifies the type of lock used for the document being edited, when the underlying document store supports locking. Currently, only WebDAV supports document locking.

    Note that the mode specified here is just a wish. XXE will adapt the lock mode to what is actually supported by the underlying document store. For example, if the Shared mode has been chosen by the user and the underlying document store only supports Exclusive locking, the document being edited will be locked using an Exclusive lock.

    Default: Exclusive

    Preference key: `lockMode`; type: `shared`, `exclusive` or `none`; default: `exclusive`.

  Identifier as a lock owner

    Specifies a free form string identifying you as the person locking a document. This string is presented to other users wishing to know who is locking a document. It is recommended to specify your email address (example: `jdoe@acme.com`).

    Default: empty string which implies `user_name`@`host_name` (example: `jdoe`@fast.acme.com)

    Preference key: `lockOwner`; type: string; default: empty string which implies `user_name`@`host_name`.

    Table 2. Lock Types

    Lock type | Description
    --- | ---
    None | The document being edited in not locked.
    Shared | The document being edited is locked using a shared lock. A shared lock does not prevent you from overwriting a document shared-locked by another author but a least, you are informed that the document is being ``used'' by this other author. (In such case, you'll generally want to contact him to decide what to do.)
    Exclusive | The document being edited is locked using an exclusive lock. An exclusive lock prevents you from overwriting a document exclusively-locked by another author.

#### 8.5.3. Save options

Encoding

  Specifies the encoding used for XML files saved by XXE (if save options have not been specified in an XXE configuration file -- see below).

  Default: the original encoding of the file.

  Preference key: `encoding`; type: any encoding supported by Java or "`ORIGINAL_ENCODING`"; default: UTF-8.

Save characters outside encoding as entity references

  If this toggle is checked, all characters not supported by the encoding are saved as entity references.

  Example: the Euro sign is not supported by the ISO-8859-1 encoding. If this toggle is checked, the Euro sign is saved as "`&euro;`". If this toggle is not checked, the Euro sign is saved as "`&#8364;`".

  Of course, for a character to be saved as an entity reference, the corresponding entity must have been defined in the DTD.

  Example: the Euro sign is not supported by the ISO-8859-1 encoding. If there is no entity defined for this currency symbol, the Euro sign is saved as "&#8364;" whether the toggle is checked or not.

  Default: checked.

  Preference key: `saveCharsAsEntityRefs`; type: boolean; default: `true`.

Always save these characters as entity references

  Specifies which characters, even if they are supported by the encoding, are always saved as entity references.

  Example: the Copyright sign is supported by the ISO-8859-1 encoding but you may prefer to see it saved as "`&copy;`". In such case, specify `"169"` in this text field.

  This attribute contains a list of character ranges. A character range is either a single character or an actual range ``char1`:`char2``.

  A character may be specified using its Unicode character number, in decimal (example: `233` for e acute), in hexadecimal (example: `0xE9`) or in octal (example: `0351`).

  Because names are easier to remember than numbers, a character may also be specified using its entity name as defined in the DocBook 4.2 DTD (example: `eacute`). Note these symbolic specifications are supported whatever is the DTD or schema of the document being saved.

  Examples: `nbsp` `160` `0xA0` `0240` `reg 174 0x00ae 0256 pound:yen 163:165 0xA3:0xA5 0243:0245`

  Default: empty.

  Ignored if toggle "Save characters outside encoding as entity references" is not checked.

  Preference key: `charsSavedAsEntityRefs`; type: specification as described above; default: empty string.

Indent

  If this toggle is checked, XML files saved by XXE are indented (if save options have not been specified in an XXE configuration file -- see below).

  The fields and toggles that follows in the Indent frame may be used to parametrize indentation.

  Default: checked.

Indentation

  Specifies the number of space characters used to indent a child element relatively to its parent element.

  Default: 2.

  Preference key: `indent`; type: integer (negative means not indented); default: 2.

Max. line length

  Specifies the maximum line length for elements containing text interspersed with child elements.

  Default: 78.

  This value is only used as a hint: XML files created by XXE may contain lines much longer than the specified length.

  Preference key: `maxLineLength`; type: positive integer; default: 78.

Add open lines

  If this toggle is checked, an open line is added between the child elements of a parent element (if the content model of the parent only allows child elements).

  Default: checked.

  Preference key: `addOpenLines`; type: boolean; default: `true`.

Favor interoperability with HTML and SGML

  If this toggle is checked:

  - Empty elements having a non empty content are saved as "`<tag></tag>`".

  - Empty elements having an empty content are saved as "`<tag />`" (with a space after the tag).

  Default: checked.

  Table 3. XHTML examples

  Toggle checked | Toggle not checked
  --- | ---
  `<p></p>` | `<p/>`
  `<br />` | `<br/>`

  Preference key: `favorInteroperability`; type: boolean; default: `true`.

Do not indent unconstrained documents

  If this toggle is checked, XML files generated by XXE when saving documents not constrained by a DTD, W3C XML Schema or RELAX NG schema, are not indented, even if the Indent toggle is checked.

  Note that when this toggle is not checked, XXE uses very simple heuristics to indent unconstrained documents. Indenting such documents this way may add white space to places where it is significant.

  Default: not checked.

  Preference key: `dontIndentUnconstrainedDocs`; type: boolean; default: `false`.

Override settings specified in config. files

  The above options can also be specified in a configuration file customizing XXE for a specific XML application.

  If this is the case, when the configuration is in use, what has been specified in the Options dialog box is completely ignored, unless this toggle is checked.

  Default: not checked.

  Preference key: `overrideConfiguration`; type: boolean; default: `false`.

Automatically save modified documents

  If this toggle is checked, XXE will automatically save modified documents.

  Default: not checked.

Max. modifications before saving

  A modified document will be automatically saved after specified number of modifications. Typing a character counts as a modification.

  Default: 300.

  Preference key: `autoSaveInterval`; type: -1000000-1000000 (number of operations; negative means disabled); default: -300.

Idle time (seconds) before saving

  If a modified document is no longer edited during specified number of seconds, this document is automatically saved, even if the "Max. modifications before saving" count has not yet been reached.

  This option allows to make the auto-save feature as non-intrusive as possible.

  Default: 30.

  Preference key: `autoSaveTimeout`; type: 10-86400 (number of seconds); default: 30.

Ensure that a save filename has an extension

  If this toggle is checked, XXE automatically appends an extension to the save filenames (File → Save As, File → Save Copy, etc) having no extension at all.

  The extension is guessed based on the current filename of the document to be saved. For example, if you save `/tmp/page.htm`l as `/home/john/index`, XXE automatically appends "`.html`". When the extension cannot be guessed this way, XXE fallbacks to "`.xml`".

  Default: checked.

  Preference key: `ensureSaveFileHasExtension`; type: boolean; default: `true`.

Before saving, make a backup copy of the file

  If this toggle is checked, a copy of the original file is made (same name but ending with '`~`') before saving the modified copy.

  Note that backup files are created at the beginning of the editing session and not each time a file is saved. This makes the backup files much more useful. For example a diff between `foo.xml~` and `foo.xml` will show you what you did during last editing session.

  Default: checked.

  Preference key: `makeBackupFiles`; type: boolean; default: `true`.

Automatically update references in modular documents

  If this toggle is checked, references found in modular documents are automatically updated each time a referenced document is saved to disk.

  Example: document `book.xml` references `chapter1.xml` and `chapter2.xml`. File `chapter2.xml` is modified and saved to disk using XXE. Nodes included in `book.xml` coming from `chapter2.xml` are automatically updated.

  Counter-example: document `book.xml` references `chapter1.xml` and `chapter2.xml`. File `chapter2.xml` references `section1.xml` and `section2.xml`. File `section2.xml` is modified then saved to disk using XXE. Nodes included in `book.xml` indirectly coming from `section2.xml` are not automatically updated. In such case, if you really want to update `book.xml`, you'll have to use View+Redraw (Ctrl+L) See note about Updating the references contained in a modular document.

  Default: checked.

  Preference key: `updateInclusionsOnSave`; type: boolean; default: `true`.

#### 8.5.4. Print options

### Note

The options for the page footer are not described here because they are identical to those used for the page header (described below).

Screen resolution

  Specifies the screen resolution in DPI (Dot Per Inch) used when printing. This resolution directly determines the amount of text a printed page can contain.

  Default: 100dpi.

  Preference key: `screenResolutionWhenPrinting`; type: 50-100; default: 100.

Begin

  The page header has 3 areas: begin (the left for left-to-right languages), middle, end (right). This field specifies the text printed at the left of the page header.

  Default: empty.

  Each area can contain a mix of text and variables

  Preference key: `headerBegin` [`footerBegin`]; type: text; default: empty [`%F`].

Middle

  Specifies the text printed at the center of the page header.

  Default: empty.

  Preference key: `headerMiddle` [`footerMiddle`]; type: text; default: empty [empty].

End

  Specifies the text printed at the right of the page header.

  Default: empty.

  Preference key: `headerEnd` [`footerEnd`]; type: text; default: empty [`%P`].

Color

  Specifies the color of the text of the page header.

  Default: gray.

  Note that the font used for the page header is the default font of the style sheet (see the View options below).

  Preference key: `headerColor` [`footerColor`]; type: 3 0-255 integers separated by spaces (specify red, green, blue); default: 128 128 128 [128 128 128].

Underline [Overline]

  Specifies if a thin line is to be printed below the page header [above the page footer].

  Default: checked.

  Preference key: `underlineHeader` [`overlineFooter`]; type: boolean; default: `true`.

Table 4. Substituted Variables

Variable | Description
--- | ---
`%F` | File name of the document being edited
`%f` | Same as `%F` but shortened to approximately 30 characters
`%B` | Base name of the document being edited
`%D` | Current date
`%T` | Current time
`%P` | Equivalent to localized "`page %I of %C`"
`%I` | Current page number
`%C` | Total page count

#### 8.5.5. Edit options

Use integrated input method support

  When an input method (e.g. Japanese Romaji Input) has been selected by the user,

  - If this toggle is checked, a composition area, managed by the XML editor, is displayed inside the document view, below the caret.

  - If this toggle is not checked, a composition window, managed by the operating system, is displayed outside the main window of the XML editor.

    Figure 15. Composition area displayed below the caret

  Default: not checked. (Slightly more efficient if you never use input methods.)

  Preference key: `activeInputMethodClient`; type: boolean; default: `false`.

Clicking with middle button pastes system selection

  If this toggle is checked, clicking with the middle button (or with the mouse wheel) pastes the characters copied to the ``system selection''.

  On platforms not supporting system selection (all but generic Unix/Linux), this action pastes the content of an internal clipboard.

  Default: not checked.

  Preference key: `button2PastesSystemSelection`; type: boolean; default: `false`.

Add interactive margin to the styled view

  If one or both of these toggles are checked, the editor adds gray margins at the left and/or at the right of the styled document views. These margins allow to trigger special, customizable, actions when the user clicks in them. By default, clicking in these margins, selects the ``block'' (paragraph, row, row group, table) in front of the click location. Clicking again without moving the mouse, selects the parent of the selected element. Clicking again without moving the mouse, selects the grand-parent, and so on.

  Do not click several times too fast otherwise the editor will think you are double-clicking or triple-clicking and therefore, selecting elements that way would not work.

  Default: not checked.

  Preference key: `addInteractiveMargin`; type: `none`, `left`, `right` or `both`; default: `none`.

Append mode

  Specifies how to quickly complete what is being typed in an autocompletion-enabled text field.

  None

    There is no quick way to complete what is being typed (other than using Up and Down arrows).

  Automatic

    What is being typed is automatically completed to compose first possible suggestion.

  Manual

    The user needs to explicitly press on the space bar (or on Ctrl+Space, if some of the choices contain whitespaces) to complete as much as possible what has been typed.

  Example: the list of choices is "`aaz aaa bbz bbb ccz ccc`". The user types "`b`".

  None

    Nothing happens and pressing on the space bar has no effect.

  Automatic

    The text field is automatically updated to contain "`bbz`".

  Manual

    Nothing happens, but pressing on the space bar will add a "`b`" to what has been typed (which gives "`bb`").

  Default: Manual.

  Preference key: `appendSuggestionMode`; type: `none`, `auto` or `manual`; default: `manual`.

In the choice list, only show suggestions

  If this toggle is checked, the list which displays possible choices (e.g. elements to be inserted in the document) is kept as short as possible.

  Default: not checked.

  By default, such list displays all possible choices, whether matching what has been typed in the autocompletion-enabled text field or not.

  Example: the list of choices is "`aaz aaa bbz bbb ccz ccc`". The user types "`b`".

  If this toggle is not checked, the list contains "`aaz aaa bbz bbb ccz ccc`" and item "`bbz`" is highlighted.

  If this toggle is checked, the list contains "`bbz bbb`" and item "`bbz`" is highlighted.

  Preference key: `onlyShowSuggestions`; type: boolean; default: `false`.

Automatically select an attribute

  When toggle Never is not checked, Tools → Edit Attribute (Ctrl+E) automatically selects an attribute of the element. The selected attribute is determined as follows, in this order:

  1. First required attribute containing the "`???`" placeholder value.

  2. First attribute, required or not, containing the "`???`" placeholder value.

  3. If toggle Unique required attribute is checked, unique required attribute, whatever its value.

  Default: First attribute containing a placeholder value.

  Preference key: `autoSelectAttribute` ; type: `never`, `placeholder` or `required`; default: `placeholder`.

Max. undo actions

  Specifies the maximum number of undo (redo) actions a user will be able to perform. Limited to 100 because a single undo action may consume a great deal of memory.

  Default: 20.

  Preference key: `maxUndo`; type: 1-100; default: 20.

Allow advanced use of XInclude

  By default, command Edit → Reference → Copy as Reference allows to copy as a reference only the root element of a document or an element having an ID. If this toggle is checked, it becomes possible to copy as a reference any range of sibling nodes.

  Default: not checked.

  Preference key: `allowAdvancedXInclude`; type: boolean; default: `false`.

Warn about advanced use of XInclude

  This checkbox is disabled unless "Allow advanced use of XInclude" has been checked.

  If this toggle is checked, you'll be informed when what you are copying as a reference qualifies as "an advanced use of XInclude". Typically you'll be informed that the element you are copying as a reference has no ID attribute.

  If you check Allow advanced use of XInclude, it is also strongly recommended to also turn this option on.

  Default: not checked.

  Preference key: `warnAboutAdvancedXInclude`; type: boolean; default: `false`.

#### 8.5.6. View options

The following options parameterize the CSS style sheet used to visualize the document or to print it.

Setting some of these preferences will have no visible effect if the style sheet author has specified the corresponding properties in the style sheet. For example, if the user's preferred background is specified in the Style section as being light yellow and if the style sheet author has specified the root element `background-color` as being white, the document will be rendered with a white background.

Serif font family

  Specifies the font family used for property value `font-family:serif`.

  Default: Serif (the Java™ default serif font family).

  Preference key: `serifFontFamily`; type: font family name; default: `Serif`.

SansSerif font family

  Specifies the font family used for property value `font-family:sans-serif`.

  Default: SansSerif (the Java™ default sans-serif font family).

  Preference key: `sansSerifFontFamily`; type: font family name; default: `SansSerif`.

Monospaced font family

  Specifies the font family used for property value `font-family:monospace`.

  Default: Monospaced (the Java™ default monospaced font family).

  Preference key: `monospaceFontFamily`; type: font family name; default: `Monospaced`.

Default font family

  Specifies the default value for property `font-family`.

  Default: SansSerif.

  Preference key: `defaultFontIsSerif`; type: boolean; default: `false`.

Default font size

  Specifies the default value for property `font-size`. See also View → Text Size.

  Default: 12pt.

  Preference key: `defaultFontSize`; type: 10-20 (pt); default: 12.

Default background

  Specifies the default value for property `background-color`. (Displays standard color chooser dialog box.)

  Default: white.

  Preference key: `defaultBackground`; type: 3 0-255 integers separated by spaces (specify red, green, blue); default: 255 255 255.

Default text color

  Specifies the default value for property `color`. (Displays standard color chooser dialog box.)

  Default: black.

  Preference key: `defaultForeground`; type: 3 0-255 integers separated by spaces (specify red, green, blue); default: 0 0 0.

The following option, which slightly modifies the behavior of word wrap in both the tree view and in the styled view, is useful to deal with long URLs and with languages such as Japanese or Chinese which do not use spaces between words.

Wrap words wider than available space

  If this toggle is checked, words which are wider than the space available in the document view, are wrapped. For example, when this toggle is not checked (note the horizontal scrollbar):

  When this toggle is checked:

  Default: not checked.

  Preference key: `wrapLongWords`; type: boolean; default: `false`.

#### 8.5.7. Tools options

##### 8.5.7.1. Spell options

General options used by both the automatic and ``traditional'' spell checkers:

Ignore case

  If this toggle is checked, ignore capitalization errors.

  Default: not checked.

  Preference key: `ignoreCase`; type: boolean; default: `false`.

Ignore mixed-case words

  If this toggle is checked, do not check words containing case mixing (e.g. "`SpellChecker`").

  Default: not checked.

  Preference key: `ignoreMixedCase`; type: boolean; default: `false`.

Ignore words with digits

  If this toggle is checked, do not check words containing digits (e.g. "`b2b`").

  Default: checked.

  Preference key: `ignoreDigits`; type: boolean; default: `true`.

Ignore URL-like words

  If this toggle is checked, ignore words looking like URLs or file names (e.g. "`www.xxx.com`" or "`c:\boot.ini`").

  Default: checked.

  Preference key: `ignoreURL`; type: boolean; default: `true`.

Ignore duplicate words

  If this toggle is checked, do not signal two successive identical words as an error.

  Default: not checked.

  Preference key: `ignoreDuplicates`; type: boolean; default: `false`.

Check punctuation

  If this toggle is checked, punctuation checking is enabled: misplaced white space and wrong sequences, like a dot following a comma, are detected.

  Default: not checked.

  Preference key: `checkPunctuation`; type: boolean; default: `false`.

Allow compounds words

  If this toggle is checked, all words formed by concatenating two legal words with an hyphen are accepted. If the language allows it, two words concatenated without hyphen are also accepted.

  Default: checked.

  Preference key: `allowCompound`; type: boolean; default: `true`.

Allow general prefixes

  If this toggle is checked, a word formed by concatenating a registered prefix and a legal word is accepted. For example if "`mini-`" is a registered prefix, accepts "`mini-computer`".

  Default: checked.

  Preference key: `allowPrefixes`; type: boolean; default: `true`.

Allow file extensions

  If this toggle is checked, accepts any word ending with registered file extensions (e.g. "`myfile.txt`", "`index.html`", etc).

  Default: checked.

  Preference key: `allowFileExtensions`; type: boolean; default: `true`.

Favor quality over speed

  For use on a fast computer. Does not influence the number of suggestions (always limited to 15).

  Default: not checked.

  Preference key: `maxSuggestionForce`; type: boolean; default: `false`.

Activation of the automatic (AKA on-the-fly) spell checker.

This group of options is present only in XMLmind XML Editor Professional Edition.

Never activate the automatic spell checker

  When a document is opened, never activate the automatic spell checker, even if this is specified in the configuration file associated to the opened document.

  Default: not checked.

Always activate the automatic spell checker

  When a document is opened, always activate the automatic spell checker, even if this is not specified in the configuration file associated to the opened document.

  Default: not checked.

Activate if this is specified in the configuration file

  When a document is opened, activate the automatic spell checker if this is specified in the configuration file associated to the opened document (using the `spellCheckOptions` configuration element, see Section 23, “spellCheckOptions” in XMLmind XML Editor - Configuration and Deployment).

  Default: checked.

  Preference key: `autoSpellCheck`; type: enumeration (`never`, `always`, `seeConfig`); default: `seeConfig`.

##### 8.5.7.2. Validate options

Automatically show Validity tool

  Document validity is automatically checked each time the document is saved to disk. If this toggle is checked, when validity errors are found, the Validity tool ``tab'' is automatically selected in order to display the error messages.

  Default: not checked.

  Preference key: `showValidityPaneOnSave`; type: boolean; default: `false`.

Filter duplicate ID errors found in modular documents

  Pasting in a document two references to the same element will cause the Validity tool to display duplicate ID errors. This is a problem because the author didn't do any mistake by pasting these two references and because too many of these ``false'' duplicate ID errors may hide real duplicate ID errors. That's why turning on this option will discard such ``false'' duplicate ID errors from the Validity tool.

  Default: checked.

  Preference key: `filterDuplicateIDs`; type: boolean; default: `true`.

##### 8.5.7.3. Spreadsheet options

This group of options is available only in XMLmind XML Editor Professional Edition, where it is hidden by default. You need to enable it by checking "Enable the Integrated Spreadsheet Engine" in Options → Preferences, Features section.

Open spreadsheets in auto-update mode

  Specifies that spreadsheets are to be opened in auto-update mode.

  In manual update mode, only newly inserted formulas are computed. To force a full calculation, the user has to explicitly use Tools → Spreadsheet → Update.

  In auto-update mode, a full calculation is automatically performed, if needed to, when the editing context changes. For example: type some text in a paragraph, then click in (or tab to) another paragraph to trigger a spreadsheet calculation.

  Note that in both modes, a full calculation is automatically performed, if needed to, before validating or saving the document.

  Using manual update mode is recommended if you have a slow computer or if you have inserted a lot of formulas in your document or if your formulas access many external documents.

  Default: checked.

  Preference key: `spreadsheetAutoRecalc`; type: boolean; default: `true`.

Maximum number of iterations allowed for calculations in spreadsheet

  Specifies the maximum number of iterations allowed for calculations in spreadsheet. This limit is used to prevent the spreadsheet engine from looping in case of cycles in formulas.

  Default: 20.

  Preference key: `spreadsheetMaxIterations`; type: 2-2000; default: `20`.

Cache external documents accessed by formulas

  Formulas can access external documents using XPath escapes (example: ``document("tutorial/VATrates.html#france_vat",.)``). Such access is generally slow and therefore, documents need to be cached the first time they are loaded.

  However, the cache is not very smart and will often not be able to detect changes in the external document. This problem will happen if the change happens in a module included by the document or if the document is stored on a remote HTTP or FTP server. In this is case, disabling the cache and also disabling the auto-update mode are recommended.

  Default: checked.

  Preference key: `spreadsheetCacheDocuments`; type: boolean; default: `true`.

##### 8.5.7.4. Helper applications options

File types

  List of file types. Each file type has an associated helper application. This helper application is assumed to be able to open files detected as having this type. A helper application may be a viewer or an editor.

  Default: the "`text/plain`" file type:

  - On Windows: `text/plain:txt:::notepad "%F"`

  - On the Mac:

    - for a version older than Mac OS X 10.5 (e.g. Tiger): `open -t"%F"`,

    - starting from Mac OS X 10.5 (Leopard): `open -W -n -t "%F"`.

    See also Helper applications on the Mac.

  - On Unix: `text/plain:txt:::xterm -e vi "%F"`

  Buttons acting on this list:

  Add

    Displays the "Helper Application Editor" dialog box in order to add a new file type to the list.

  Edit

    Displays the "Helper Application Editor" dialog box in order to view or modify selected file type.

  Remove

    Removes selected file type from the list.

  Preference key: `helperApplications.entries`; type: string; default: see above. The format of this string is:

      entries --> ( entry ('\n' entry)* )?

      entry --> mime_types ':' extensions ':' magic_strings ':'
                xml_name_patterns ':' command

      mime_types --> (mime_type (',' mime_type)* )?
      extensions --> (extension (',' extension)* )?
      magic_strings --> (magic_string (',' magic_string)* )?
      xml_name_patterns --> (xml_name_pattern (',' xml_name_pattern)* )?

      In any of the above fields, character ':' must be escaped using "\072"
      and character ',' must be escaped using "\054".

      magic_string --> HEXADECIMAL_NUMBER

      xml_name_pattern --> ( '{' namespace_URI? '}' )? local_part
      One of local_part or namespace_URI may be equal to "*".

Default viewer

  Specifies which default viewer to use in case the type of the file to be opened has not been detected. In practice, commands making use of the default viewer typically assumes that it is in fact a Web browser. This implies that these commands assume that a default viewer can open URLs as well as filenames and that it can open text, html, GIF, PNG and JPEG files.

  This field must contain a command line interpreted by the native shell of the platform: `cmd.exe` on Windows and `/bin/sh` on the Mac and on Unix.

  This command line must reference one of these two substituted variables: `%U` and `%F`. In principle, `%U` is replaced by the URL of the file to be opened by the helper application and `%F` is replaced by a filename. In practice, `%U` is just a hint meaning: the helper application can open URLs as well as filenames.

  Default: depends on the platform:

  - On Windows: `start "" "%U"`

  - On the Mac: `open "%U"`

  - On Unix: dynamically detected. By default: `(mozilla -remote "openURL(%U)" 1> /dev/null 2>&1)|| (mozilla "%U" &)`

  Buttons acting on this field:

  Reset

    Resets the field to its default value (see above).

  Choose

    Displays the standard file chooser in order to specify an application (e.g. a `.exe` or a `.bat` file on Windows). String "`"%F"`" is automatically appended to the chosen application.

    See also Helper applications on the Mac.

  Preference key: `helperApplications.defaultViewer`; type: string; default: see above.

#### 8.5.8. Window options

Show both tree and styled views

  If this toggle is checked, XXE will automatically create two views for a newly opened or newly created document. That is, by default, a document tab will contain a tree view and a styled view side by side.

  This option has of course no effect on documents for which no CSS style sheet is available.

  Default: not checked.

  Preference key: `showBothViews`; type: boolean; default: `false`.

Place tree view at right

  If this toggle is checked, the tree view is to be placed at the right of the styled view.

  Default: not checked.

  Preference key: `treeViewAtRight`; type: boolean; default: `false`.

Tree view width

  Specifies the width of the tree view in percentage of the available window area.

  Default: 33%.

  Preference key: `treeViewPercent`; type: 10-90; default: `33`.

#### 8.5.9. Install add-ons options

### Note

This preference sheet is absent when XMLmind XML Editor has been started using Java™ Web Start.

Download add-ons from these servers

  Add-ons available for download are listed in `.xxe_addon` files. The list of ``servers'' below this checkbox contains the URLs of these `.xxe_addon` files. Use button Add to add an URL to the list. Use button Remove to remove selected URL from the list. Use button Reset to reset the list to its default value.

  Default: checked. The default value of the list of ``servers'' is:

  - http://www.xmlmind.com/xmleditor/_usercontrib/list.xxe_addon

  - `http://www.xmlmind.net/xmleditor/_download/list-`${XXE_VERSION}`.xxe_addon` (for example, variable `${XXE_VERSION}` is replaced by "`3_5_2`" if the version of the running XML Editor is v3.5.2)

  - http://www.xmlmind.net/xmleditor/_download/list.xxe_addon

  Preference keys: `addonSource`; type: `servers`|`directory`|`both`; value: `servers`, or `both` if "Search add-ons in this directory" is also checked. The list of ``servers'' is specified by key; `addonServers`; type: list of URLs separated by newline characters ('`\n`'); default: see above URLs.

Search add-ons in this directory

  Zip files containing add-ons may have been downloaded using a Web browser and then copied to a local directory (for example, because you have problems downloading add-ons directly from XXE). In such case, check this box and specify in the text field below it this local directory.

  Note that this directory may also contain unzipped add-ons (not recommended though). This is useful because sometimes Web browsers have the bad habit of automatically unzipping the downloaded Zip files.

  Default: not checked. No local directory containing Zip files.

  Preference keys: `addonSource`; type: `servers`|`directory`|`both`; value: `directory`, or `both` if "Download add-ons from these servers" is also checked. The local directory is specified by key: `addonDir`; type: the filename of an existing directory; default none.

Install add-ons in the user's preferences directory

  Install all types of add-ons in ``XXE_user_preferences_dir`/addon/`, where `XXE_user_preferences_dir` is:

  - ``$HOME`/.xxe4/` on Linux.

  - ``$HOME`/Library/Application Support/XMLmind/XMLEditor4/` on the Mac.

  - ``%APPDATA%`\XMLmind\XMLEditor4\` on Windows 2000, XP, Vista.

    Example: `C:\Documents and Settings\john\Application Data\XMLmind\XMLEditor4\` on Windows 2000 and XP. `C:\Users\john\AppData\Roaming\XMLmind\XMLEditor4\` on Windows Vista.

  This radiobutton is disabled (grayed) if you have insufficient privileges to create files in this directory.

  Default: not checked.

  Preference key: `addonInstallDir`; type: `user`|`system`|`best`; value: `user`.

Install add-ons in XXE installation directory

  Install all types of add-ons in ``XXE_install_dir`/addon/`, where ``XXE_install_dir`` is, for example, on Windows, `C:\Program Files\XMLmind_XML_Editor`.

  This radiobutton is disabled (grayed) if you have insufficient privileges to create files in this directory.

  Default: not checked.

  Preference key: `addonInstallDir`; type: `user`|`system`|`best`; value: `system`.

Installation directory depends on the add-on

  Add-ons which depend on a specific version of XXE are installed in ``XXE_install_dir`/addon/`, other add-ons are installed in ``XXE_user_preferences_dir`/addon/`.

  This way, the add-ons which depend on a specific version of XXE, are automatically uninstalled when, in the future, you'll upgrade the application. The other add-ons, which do not on a specific version of XXE, are not uninstalled when, in the future, you'll upgrade the application.

  In practice, the following add-ons are installed in ``XXE_install_dir`/addon/`:

  - XSL-FO processor plug-ins.

  - Image toolkit plug-ins.

  - Non-XML format plug-ins.

  - Virtual drive plug-ins.

  - Configurations, customizing XXE for a given document type, which include custom commands written in Java™.

  On the other hand, the following add-ons are installed in ``XXE_user_preferences_dir`/addon/`:

  - Translations of XXE to languages other than English.

  - Spell checker dictionaries other than the English one.

  - Configurations, customizing XXE for a given document type, which don't include custom commands written in Java™.

  Note that this radiobutton is disabled (grayed) if you have insufficient privileges to create files in the ``XXE_user_preferences_dir`/addon/` directory or in the ``XXE_install_dir`/addon/` directory, that is, when there is no possible choice for the installation directory.

  Default: checked.

  Preference key: `addonInstallDir`; type: `user`|`system`|`best`; value: `best`.

#### 8.5.10. General options

Use a unique instance of XMLmind XML Editor

  If this toggle is checked, a unique instance of XMLmind XML Editor is used to open all your XML documents. For example, if you double-click on the icon of an XML document in the file ``explorer'', the running instance is used to open this XML document. When this toggle is not checked, a new instance of XXE is started in order to load the document clicked upon.

  If there is no running instance of XXE, a new instance is started. If the running instance is hidden by other windows or is iconified, it is made visible before opening the requested document.

  This feature also works fine from the command line. For example, on Linux, if this toggle is checked, executing "`xxe mydoc.xml &`" will cause the running instance to be used to open `mydoc.xml`.

  If you need to change this option, make sure to close all running instances expect one. Then change the option in the last instance and close it. Then restart XXE.

  Default: not checked.

  Preference key: `singleInstance`; type: boolean; default: `false`.

Port

  Specifies the TCP/IP port used by different instances of XXE to communicate with each other. It is highly recommended to use a port in the dynamic/private range: 49152 to 65535.

  Default: 49987

  Preference key: `singleInstancePort`; type: 1-65535; default: `49987`.

Font size

  May be used to change the base font size of XXE menus and dialog boxes.

  This font size is also used to compute the base font size of the tree view. If you need to change the base font size of styled views, you need to use a different option: see Default font size in View Options.

  Default: default base font size of Java™ applications.

  Preference key: `fontSize`; type: 10-20 or -1 (means default); default: -1.

Text anti-aliasing

  If this toggle is checked, text looks much nicer at the expense of rendering speed.

  It is strongly recommended to turn this option off if you run XXE on an old computer. Text anti-aliasing is quite CPU-intensive and therefore makes XXE sluggish on old machines.

  When used with Java™ 1.5+, the whole GUI of XXE is anti-aliased. When used with Java™ 1.4, only the text of the document views is anti-aliased.

  Note that turning on this option is not needed on the Mac where anti-aliasing is part of the Aqua Look&Feel.

  Preference key: `textAntiAliasing`; type: boolean; default: `true`. No effect on the Mac.

Locale

  May be used to force the language used in XXE menus and dialog boxes. For example, may be used to force the use of English on a machine where the default locale is German.

  Default: default locale of the machine running XXE.

  Preference key: `locale`; type: `language` (e.g. `fr`) or `language`_`COUNTRY` (e.g. `fr_CA`) or - (means default); default: -.

Style

  May be used to change the look and feel of XXE user interface.

  Default: the system look and feel, except on Linux/Unix, where the cross-platform look and feel (Metal) is used.

  Preference key: `lookAndFeelClassName`; type: Java™ class name of a PLAF or - (means default); default: -.

Automatically reopen last opened document

  This option is examined just after XXE is started, when no documents to be opened have been explicitly specified (e.g. by double-clicking on an XML file or by using command line options). When turned on, this option forces XXE to reopen the last document opened during the preceding editing session.

  Preference key: `reopenLastOpenedFile`; type: boolean; default: `false`.

  See also the -last command line option for a handy alternative.

##### 8.5.10.1. Features Options

Features which are not useful in the general case are hidden by default. You need to check the toggle corresponding to a feature and then restart XXE in order to enable this feature.

Enable the Include Tool

  Check this toggle to enable Edit → Reference → Replace By Reference, Edit → Reference → Insert Reference Before, Edit → Reference → Insert Reference, Edit → Reference → Insert Reference After and the Include tool.

  Feature name: `IncludeTool`.

Enable the Integrated Spreadsheet Engine

  Check this toggle to enable Tools → Spreadsheet and the Options → Preferences, Tools|Spreadsheet group of options.

  Feature name: `Spreadsheet`.

  This option is present only in XMLmind XML Editor Professional Edition.

Enable the Developer Tools

  Check this toggle to enable Options → Reload All Configurations and Help → Mouse and Key Bindings.

  Feature name: `DeveloperTools`.

Preference key: `features`; type: list of feature names (`IncludeTool`, `Spreadsheet`, etc) separated by newline characters; default: empty list.

#### 8.5.11. Advanced options

##### 8.5.11.1. Schema cache options

When an instance document conforming to a grammar (DTD, W3C XML Schema or RELAX NG Schema) is opened in XXE, the grammar is checked for validity, then the instance document is checked for validity.

Checking a grammar for validity may be a lengthy operation for a medium-size W3C XML schema and for a large DTD such as DocBook.

Therefore, if the option is enabled, XXE checks the grammar the first time it is used by an instance document and then caches it for subsequent uses. The grammar is cached

1. in memory,

2. on disk using a fast loading binary format (DTD, W3C XML Schema but not RELAX NG Schema).

   The directory used to store the fast loading binary files is ``XXE_user_preferences_dir`/ser/`. XXE user preferences directory is:

   - ``$HOME`/.xxe4/` on Linux, Mac, and more generally, on Unix.

   - ``%APPDATA%`\XMLmind\XMLEditor4\` on Windows 2000, XP, Vista.

     Example: `C:\Documents and Settings\john\Application Data\XMLmind\XMLEditor4\` on Windows 2000 and XP. `C:\Users\john\AppData\Roaming\XMLmind\XMLEditor4\` on Windows Vista.

The cache records the location and date of the source files of the grammar. If these source files are removed or modified, the cache will automatically discard the obsolete cached grammar. Of course, this forces XXE to load an up-to-date grammar from the source files.

Note that the existence and date of remote source files (that is, grammar files located on a HTTP or FTP server) are not checked by the schema cache.

Enable cache

  Enables the behavior described above.

  Disabling this option is a good idea if you exclusively use small or medium size DTDs such as XHTML.

  Default: checked.

  Preference key: `useDocTypeCache`; type: boolean; default: `true`.

Clear cache

  Clears the cache forcing XXE to reload a grammar from its source files and to revalidate it next time it is used by an instance document.

  This option is useful if you are developing grammars and using XXE to check them.

  Note that the cache is automatically cleared each time you install a new version of XXE.

##### 8.5.11.2. Proxies options

### Note

This preference sheet is absent when XMLmind XML Editor has been started using Java™ Web Start. In such case, proxy servers must be configured using the Java™ Control Panel.

A proxy server is a service which allows clients such Web browsers or XMLmind XML Editor to make indirect network connections to other HTTP, FTP, etc, servers. A common proxy server is a caching Web proxy. This proxy provides a nearby cache of Web pages and files available on remote Web servers, allowing clients to access them quickly and reliably.

That's why, if you have problems listing or downloading available add-ons using Options → Install Add-ons, may be your organization uses a proxy server to make connections to the Internet and in such case, this proxy server needs to be declared using this preference sheet.

Direct connection to the Internet

  Do not use the services of proxy servers, if any. Make direct connections to the Internet.

  Default: checked if Java™ 1.4 is used to run XXE; otherwise not checked.

  Preference key: `proxySettings`; type: `none`|`system`|`application`; value: `none`.

Use system settings

  Use what has been specified in the ``control panel'' of your desktop/operating system. For example, on Windows, you'll find these settings in Control Panel > Internet Options > Connections tab > LAN Settings.

  Only available if Java™ 1.5+ is used to run XXE. Only works on Windows and on Linux/Gnome.

  Default: checked if Java™ 1.5+ is used to run XXE; otherwise not checked and disabled.

  Preference key: `proxySettings`; type: `none`|`system`|`application`; value: `system`.

Manual proxy configuration

  Specify which proxy server to use for which network protocol. Please ask your network administrator to help you fill this form.

  Default: not checked.

  Preference key: `proxySettings`; type: `none`|`system`|`application`; value: `application`.

  HTTP proxy

    Specifies the host name of the proxy server to use when HTTP connections are made.

    Default: none.

    Preference key: `httpProxyHost`; type: host name or host address; default: none.

  (HTTP proxy) Port

    Specifies the port number of the proxy server to use when HTTP connections are made.

    Default: 80.

    Preference key: `httpProxyPort`; type: `int`; default: 80.

  HTTPS proxy

    Specifies the host name of the proxy server to use when HTTPS connections are made.

    Default: none.

    Preference key: `httpsProxyHost`; type: host name or host address; default: none.

  (HTTPS proxy) Port

    Specifies the port number of the proxy server to use when HTTPS connections are made.

    Default: 443.

    Preference key: `httpsProxyPort`; type: `int`; default: 443.

  FTP proxy

    Specifies the host name of the proxy server to use when FTP connections are made.

    Default: none.

    Preference key: `ftpProxyHost`; type: host name or host address; default: none.

  (FTP proxy) Port

    Specifies the port number of the proxy server to use when FTP connections are made.

    Default: 80.

    Preference key: `ftpProxyPort`; type: `int`; default: 80.

  SOCKS proxy

    Specifies the host name of the SOCKS V4 or V5 proxy server to use when network connections of any sort are made.

    Default: none.

    Preference key: `socksProxyHost`; type: host name or host address; default: none.

  (SOCKS proxy) Port

    Specifies the port number of the SOCKS V4 or V5 proxy server to use when network connections of any sort are made.

    Default: 1080.

    Preference key: `socksProxyPort`; type: `int`; default:1080.

    Authenticate SOCKS user

      Check this toggle if the SOCKS proxy server of your organization requires you to authenticate yourself before using its services.

      Default: not checked.

      Preference key: `socksProxyAuthentication`; type: boolean; default: false.

    (SOCKS) Username

      Your name as a user of the SOCKS proxy server.

      Default: the login name of the user.

      Preference key: `socksUser`; type: string; default: the login name of the user.

    (SOCKS) Password

      Your password as a user of the SOCKS proxy server.

      Default: the empty string.

      Preference key: `socksPassword`; type: encoded string; default: the empty string.

  No proxy for

    When XMLmind XML Editor runs on these hosts, do not the services of proxy servers, if any. Make direct connections to the Internet.

    Default: "`localhost 127.0.0.1`".

    Preference key: `nonProxyHosts`; type: list of host names, host addresses and domain names (e.g. `.acme.com`) separated by spaces; default: "`localhost 127.0.0.1`".

Prev | Up | Next
8.4. The spreadsheet formula editor | Home | 8.6. The "Install Add-ons" dialog box